
/* gg630504.hg9ieg 2011-08-25 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "ggstd.h"

#define iFieldLim	100
#define iFormatLim	32
#define iLinLim		1024


typedef	struct	{
CH		chType;
SZ		szValue;
}		FIELD;


FIELD		FieldMp[iFieldLim] = { {0} };
I		iFieldMax = 0;
I		iFormatMax = 0;
I		iRecCnt = 0;
SZ		szFormatMp[iFormatLim] = { 0 };

//---------------------------------------------------------------------
// kiírja az i_. mezőt.
// f_, ha hívójel
R		RWriteIF( I, F );
R		RWriteIF( i_, f_ )
I		i_;
F		f_;
{
if( i_ >= iFieldMax )
	return( rNotFound );
if( f_ )
	fprintf( stdout, "%-10s", FieldMp[i_].szValue );
else	{
	if( FieldMp[i_].chType == 'd' )
		FieldMp[i_].szValue[10] = chEos; // dátum, csak az eleje kell
	fputs( FieldMp[i_].szValue, stdout );
	}
return( rSucced );
}

//---------------------------------------------------------------------
// kiírja az aktuális rekordot ( sort )
R		RWriteV( void );
R		RWriteV()
{
I		iField;
I		iFormatCh;
I		iFormatLin;
R		r = rSucced;

for( iFormatLin = 0; iFormatLin < iFormatMax; iFormatLin++ )
	{
	iFormatCh = 0;
	while( szFormatMp[iFormatLin][iFormatCh] != chEos )
		{
		switch( szFormatMp[iFormatLin][iFormatCh] )
			{
		case '[':
			iField = 0;
			iFormatCh++;
			while( (UCH)szFormatMp[iFormatLin][iFormatCh] >= '0' && (UCH)szFormatMp[iFormatLin][iFormatCh] <= '9' )
				{
				iField = 10*iField + (UCH)szFormatMp[iFormatLin][iFormatCh] - '0';
				iFormatCh++;
				}
			RWriteIF( iField, fFalse );
			break;
		case '{':
			iField = 0;
			iFormatCh++;
			while( (UCH)szFormatMp[iFormatLin][iFormatCh] >= '0' && (UCH)szFormatMp[iFormatLin][iFormatCh] <= '9' )
				{
				iField = 10*iField + (UCH)szFormatMp[iFormatLin][iFormatCh] - '0';
				iFormatCh++;
				}
			RWriteIF( iField, fTrue );
			break;
		default:
			if( (UCH)szFormatMp[iFormatLin][iFormatCh] >= ' ' || (UCH)szFormatMp[iFormatLin][iFormatCh] == '\t' )
				fputc( szFormatMp[iFormatLin][iFormatCh], stdout );
			}
		iFormatCh++;
		}
	fputc( '\n', stdout );
	}
iRecCnt++;

return( r );
}


//---------------------------------------------------------------------
// átmásolja az állományt
R		RCopyV( void );
R		RCopyV()
{
I		i;
R		r = rSucced;
SZ		szAct;
SZ		szLeft;
SZ		szLin;
SZ		szRight;

if( ( szLin = malloc( iLinLim+2 ) )==NULL ) { r = rNotMemo; goto ret; }

// első rekord kihagyása
while( (szLin = fgets( szLin, iLinLim, stdin ) )!=NULL && strncmp( szLin, "</Row>", 6 )!=0 )
	;

while( (szLin = fgets( szLin, iLinLim, stdin ) )!=NULL )
	{
	szLin[iLinLim-1] = chEos;

	if( strncmp( szLin, "<Row>", 5 )==0 )
		{
		for( i = 0; i < iFieldLim; i++ )
			ifree( FieldMp[i].szValue );
		iFieldMax = 0;
		}

	if( ( szRight = strstr(szLin, "</Data>"))!=NULL && iFieldMax < iFieldLim )
		{
		if( ( szLeft = strstr(szLin, "<Data ss:Type=\"String\">" ) )!=NULL )
			{
			szLeft += 23;
			FieldMp[iFieldMax].chType = 's';
			if( ( szAct = FieldMp[iFieldMax].szValue = malloc( (szRight-szLeft)+2 ) )==NULL ) { r = rNotMemo; goto ret; }
			while( szLeft != szRight )
				*szAct++ = *szLeft++;
			*szAct = chEos;
			iFieldMax++;
			}

		if( ( szLeft = strstr(szLin, "<Data ss:Type=\"Number\">" ) )!=NULL )
			{
			szLeft += 23;
			FieldMp[iFieldMax].chType = 'n';
			if( ( szAct = FieldMp[iFieldMax].szValue = malloc( (szRight-szLeft)+2 ) )==NULL ) { r = rNotMemo; goto ret; }
			while( szLeft != szRight )
				*szAct++ = *szLeft++;
			*szAct = chEos;
			iFieldMax++;
			}

		if( ( szLeft = strstr(szLin, "<Data ss:Type=\"DateTime\">" ) )!=NULL )
			{
			szLeft += 25;
			FieldMp[iFieldMax].chType = 'd';
			if( ( szAct = FieldMp[iFieldMax].szValue = malloc( (szRight-szLeft)+2 ) )==NULL ) { r = rNotMemo; goto ret; }
			while( szLeft != szRight )
				*szAct++ = *szLeft++;
			*szAct = chEos;
			iFieldMax++;
			}
		}

	if( strncmp( szLin, "</Row>", 6 )==0 )
		{
		RWriteV();
		for( i = 0; i < iFieldLim; i++ )
			ifree( FieldMp[i].szValue );
		iFieldMax = 0;
		}
	}

ret:
ifree( szLin );
return( r );
}



//---------------------------------------------------------------------
// beolvassa a formátum állományt
R		RInitSz( SZ );
R		RInitSz( sz_ )
SZ		sz_; // állomány útvonala, például c.fmt
{
FILE *		hIn = NULL;
R		r = rSucced;
SZ		szLin = NULL;


if( ( szLin = malloc( iLinLim+2 ) )==NULL ) { r = rNotMemo; goto ret; }
if( (hIn = fopen( sz_, "r" )) == NULL ) { r = rOpen; goto ret; }

while( (szLin = fgets( szLin, iLinLim, hIn )) != NULL && iFormatMax < iFormatLim )
	{
	szLin[iLinLim-1] = chEos;
	if( (UCH)*szLin>=' ' )
		{
		if( ( szFormatMp[iFormatMax] = malloc( strlen(szLin)+2 ) )==NULL ) { r = rNotMemo; goto ret; }
		strcpy( szFormatMp[iFormatMax++], szLin );
		}
	}

ret:
ifree( szLin );
if( hIn != NULL ) fclose( hIn );
return( r );
}

//---------------------------------------------------------------------
// felszabadítja a formátum állományt a memóriából
R		RExitV( void );
R		RExitV()
{
I		i;
R		r = rSucced;

for( i = 0; i < iFormatMax; i++ )
	ifree( szFormatMp[i] );

return( r );
}

//---------------------------------------------------------------------
// kiírja az xml első rekordját ( sorát ), hogy könnyebb legyen formátum állományt szerkeszteni
R		RFirstRecV( void );
R		RFirstRecV()
{
I		iFld = 0;
R		r = rSucced;
SZ		szLeft;
SZ		szLin = NULL;
SZ		szRight;

if( ( szLin = malloc( iLinLim+2 ) )==NULL ) { r = rNotMemo; goto ret; }

while( (szLin = fgets( szLin, iLinLim, stdin ) )!=NULL && strncmp( szLin, "</Row>", 6 )!=0 )
	{
	szLin[iLinLim-1] = chEos;
	if( ( szRight = strstr(szLin, "</Data>"))!=NULL )
		{
		if( ( szLeft = strstr(szLin, "<Data ss:Type=\"String\">" ) )!=NULL )
			{
			fprintf( stdout, "[%d]\t", iFld );
			for( szLeft += 23; szLeft != szRight; ++szLeft )
				fputc( *szLeft, stdout );
			fprintf( stdout, "\n" );
			++iFld;
			}
		}
	}

ret:
ifree( szLin );
return( r );
}

//---------------------------------------------------------------------
// stdout: 5di
// stdin: NMHH/xml
// 1. paraméter: formátum állomány azonosítója
R		main( cv_, pszv_, psze_ )
C		cv_;
PSZ		pszv_;
PSZ		psze_;
{
R		r = 0;

fprintf( stderr, "5di_xml: NMHH hívójelkönyv konvertáló GG630504 HG9IEG " __DATE__ "\n" );

if( cv_ < 2 )
	RFirstRecV();
else	{
	if( RInitSz( pszv_[1] ) < 0 ) { r = 1; goto ret; }
	RCopyV();
	fprintf( stderr, "%d rekord.\n", iRecCnt );
	}

ret:
RExitV();
return( r );
}

